#include "testlib.h"

using namespace std;

inline char view(int mask) {
    if (mask < 2) return '#' + mask;
    if (mask < 12) return '0' + mask - 2;
    if (mask < 38) return 'A' + mask - 12;
    return 'a' + mask - 38;
}

inline string view(vector<bool> const &v) {
    string s;
    for (int i = 0; i < v.size(); i += 6) {
        int mask = 0;
        for (int j = 0; j < 6; j++) {
            mask = (mask << 1u) | v[i + j];
        }
        s.push_back(view(mask));
    }
    return s;
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int k = opt<int>("k"), m = opt<int>("m");
    int shw = opt<int>("shw"), btc = opt<int>("btc");
    double noise = opt<double>("noise");

    println(k, m);
    int sz = 6 * k;
    for (int i = 0; i < m; i++) {
        vector<bool> word(sz), shift(sz);
        int cnt = btc == -1 ? rnd.next(0, sz): btc;
        auto pos = rnd.distinct(cnt, sz);
        for (int j: pos) word[j] = true;

        int sh = rnd.wnext(0, sz - 1, shw);
        if (rnd.next() < noise) {
            sort(pos.begin(), pos.end());
            vector<int> d;
            for (int t = 0; t + 1 < pos.size(); t++)
                d.push_back(pos[t + 1] - pos[t]);

            if (d.empty()) {
                pos.push_back(pos.empty() ? rnd.next(sz) : (pos[0] + 1) % sz);
            } else if (d.size() == 1) {
                pos[1] = (pos[1] + 1) % sz;
            } else {
                do {
                    int i1 = rnd.next(d.size()), i2 = rnd.next(d.size());
                    while (i1 == i2) i2 = rnd.next(d.size());
                    swap(d[i1], d[i2]);
                } while (rnd.next(2));
                for (int t = 0; t < pos.size() - 1; t++) {
                    pos[t + 1] = (pos[t] + d[t]) % sz;
                }
            }
        }
        for (int j: pos) shift[(j + sh) % sz] = true;

        cout << view(word) << ' ' << view(shift) << '\n';
    }

}