#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group() == "" ? -1 : atoi(validator.group().c_str());

    int k = inf.readInt(1, 2500, "k");
    inf.readSpace();
    int m = inf.readInt(1, 1000, "m");
    inf.readEoln();

    string temp = format("[#$0-9a-zA-Z]{%d}", k);
    vector<string> xs;
    for (int i = 0; i < m; i++) {
        xs.push_back(inf.readToken(temp, format("x_%d", i + 1)));
        inf.readSpace();
        inf.readToken(temp, format("y_%d", i + 1));
        inf.readEoln();
    }

    switch (group) {
        case 1:
            ensuref(k == 1, "k = %d is not equal to 1", k);
            ensuref(m <= 200, "m = %d is greater than 200", m);
            break;
        case 2:
            ensuref(k <= 10, "k = %d is greater than 10", k);
            for (int i = 1; i < m; i++)
                ensuref(xs[i] == xs[0], "x_%d != x_0", i + 1);
            break;
        case 3:
            ensuref(k <= 2, "k = %d is greater than 2", k);
            break;
        case 4:
            ensuref(k <= 50, "k = %d is greater than 50", k);
            ensuref(m <= 200, "m = %d is greater than 200", m);
            break;
        case 5:
            ensuref(k <= 300, "k = %d is greater than 50", k);
            ensuref(m <= 300, "m = %d is greater than 200", m);
            break;
        case 6:
            ensuref(k == 1024, "k = %d is not equal to 256", k);
            ensuref(m <= 700, "m = %d is greater than 1000", m);
            break;
    }

    inf.readEof();

}