#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef pair<ll, ll> point;
typedef pair<int, int> edge;

int n, m, s;
vector<point> points;
set<edge> edges;

const double PId4 = atan(1.0);

ll scvmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.first - a1.first;
    ll x2 = b2.first - b1.first;
    ll y1 = a2.second - a1.second;
    ll y2 = b2.second - b1.second;
    return x1 * x2 + y1 * y2;
}

ll vectmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.first - a1.first;
    ll x2 = b2.first - b1.first;
    ll y1 = a2.second - a1.second;
    ll y2 = b2.second - b1.second;
    return x1 * y2 - x2 * y1;
}

bool is_angle_in_pid4_0(const point a1, const point a2, const point b1, const point b2) {
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return vectmpv < 0 && -vectmpv < scvmp(a1, a2, b1, b2);
}

bool is_angle_in_0_pid4(const point a1, const point a2, const point b1, const point b2) {
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return 0 < vectmpv && vectmpv < scvmp(a1, a2, b1, b2);
}

bool is_angle_in_pid45_45(const point a1, const point a2, const point b1, const point b2) {
    ll scvmpv = scvmp(a1, a2, b1, b2);
    return 0 < scvmpv && abs(vectmp(a1, a2, b1, b2)) < scvmpv;
}

bool is_angle_0(const point a1, const point a2, const point b1, const point b2) {
    return vectmp(a1, a2, b1, b2) == 0 && scvmp(a1, a2, b1, b2) > 0;
}


ll dist(const point a, const point b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

ll checked_sum(ll a, ll b, InStream &inStream, int segno) {
    if (a < b) { swap(a, b); }
    inStream.ensuref(b < LLONG_MAX - a, "total power for segments 1..%d is too large", segno);
    return a + b;
}

ll readAnswer(InStream &inStream) {
    int elenght = inStream.readInt(0, n, "k");
    ll dist_ans = inStream.readLong(0, LLONG_MAX, "ans");
    int ps = s;
    int pps = -1;
    set<int> used_points;
    used_points.insert(s);
    ll real_ans = 0;
    for (int i = 0; i < elenght; ++i) {
        int vl = inStream.readInt(1, n, format("L_%d", i + 1)) - 1;
        int vt = inStream.readInt(1, n, format("B_%d", i + 1)) - 1;
        int vr = inStream.readInt(1, n, format("R_%d", i + 1)) - 1;
        inStream.ensuref(used_points.find(vl) == used_points.end(), "node %d already used", vl + 1);
        used_points.insert(vl);
        inStream.ensuref(used_points.find(vt) == used_points.end(), "node %d already used", vt + 1);
        used_points.insert(vt);
        inStream.ensuref(used_points.find(vr) == used_points.end(), "node %d already used", vr + 1);
        used_points.insert(vr);
        inStream.ensuref(edges.find(make_pair(ps, vt)) != edges.end(), "edge %d-%d not exist graph", ps + 1, vt + 1);
        inStream.ensuref(edges.find(make_pair(ps, vl)) != edges.end(), "edge %d-%d not exist graph", ps + 1, vl + 1);
        inStream.ensuref(edges.find(make_pair(ps, vr)) != edges.end(), "edge %d-%d not exist graph", ps + 1, vr + 1);

        point l = points[vl];
        point r = points[vr];
        point t = points[vt];
        point p = points[ps];

        if (ps != s) {
            inStream.ensuref(is_angle_in_pid45_45(p, points[pps], t, p), /*-PId4 < wangle && wangle < PId4*/
                             "angle between segments (%d->%d, %d->%d) must be less than 45", vt + 1, ps + 1, ps + 1,
                             pps + 1);
            inStream.ensuref(is_angle_in_pid45_45(p, points[s], t, p), /*-PId4 < tangle && tangle < PId4*/
                             "angle between segments (%d->%d, %d->S) must be less than 45", vt + 1, ps + 1, ps + 1);
        }
        inStream.ensuref(!is_angle_0(l, p, t, p), "edge %d->%d is parallel to %d->%d", vl + 1, ps + 1, vt + 1, ps + 1);
        inStream.ensuref(!is_angle_0(r, p, t, p), "edge %d->%d is parallel to %d->%d", vr + 1, ps + 1, vt + 1, ps + 1);
        inStream.ensuref(is_angle_in_pid4_0(l, p, t, p) /*0 < langle & langle < PId4 */
                         && is_angle_in_0_pid4(r, p, t, p), /*-PId4 < rangle && rangle < 0*/
                         "edges %d->%d, %d->%d, %d->%d have incorrect mutual arrangement",
                         vt + 1, ps + 1, vl + 1, ps + 1, vr + 1, ps + 1);
        inStream.ensuref(dist(p, l) <= dist(p, t), "left leg |%d->%d| > segment base |%d->%d|", vl + 1, ps + 1, vt + 1,
                         ps + 1);
        inStream.ensuref(dist(p, r) <= dist(p, t), "right leg |%d->%d| > segment base |%d->%d|", vr + 1, ps + 1, vt + 1,
                         ps + 1);

        real_ans = checked_sum(real_ans, dist(points[vt], points[ps]), inStream, i + 1);
        pps = ps;
        ps = vt;
    }
    inStream.ensuref(dist_ans == real_ans, "real power is %lld, expected ans = %lld", dist_ans, real_ans);
    return dist_ans;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    m = inf.readInt();
    s = inf.readInt() - 1;

    points.resize(n);
    for (int i = 0; i < n; ++i) {
        points[i].first = inf.readLong();
        points[i].second = inf.readLong();
    }

    for (int i = 0; i < m; ++i) {
        int u = inf.readInt() - 1;
        int v = inf.readInt() - 1;
        edges.emplace(u, v);
        edges.emplace(v, u);
    }

    ll juryAnswer = readAnswer(ans);
    ll pAnswer = readAnswer(ouf);
    if (juryAnswer < 0) {
        quitf(_fail, "invalid jury answer %lld", juryAnswer);
    }
    if (pAnswer < 0) {
        quitf(_wa, "invalid participant answer %lld", pAnswer);
    }
    if (juryAnswer < pAnswer) {
        quitf(_fail, "participant's answer %lld is better than jury's", pAnswer);
    }
    if (juryAnswer > pAnswer) {
        quitf(_wa, "jury's answer is better than participant's %lld", pAnswer);
    }
    quitf(_ok, "%lld", juryAnswer);
}
