using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second


typedef pair<pair<ll, int>, pair<int, int>> edges_dp_v;
typedef pair<ll, ll> point;
typedef pair<point, point> vect; // a->b
typedef tuple<ll, int, int, int> edge;
typedef double vangle;
typedef pair<vangle, pair<ll, int>> cleg; // angle<vu, us>, dist(v, u), v_number

vect normal(const vect v) { // vect a->b -> vect c->b
    return mp(mp(v.Y.X - (v.Y.Y - v.X.Y), v.Y.Y + (v.Y.X - v.X.X)), v.Y);
}

ll dist(const point a, const point b) {
    return sqr(a.first - b.first) + sqr(a.second - b.second);
}

ll scvmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.X - a1.X;
    ll x2 = b2.X - b1.X;
    ll y1 = a2.Y - a1.Y;
    ll y2 = b2.Y - b1.Y;
    return x1 * x2 + y1 * y2;
}

ll vectmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.X - a1.X;
    ll x2 = b2.X - b1.X;
    ll y1 = a2.Y - a1.Y;
    ll y2 = b2.Y - b1.Y;
    return x1 * y2 - x2 * y1;
}

// angle (a1->a2)^(b1->b2)
vangle angle(const point a1, const point a2, const point b1, const point b2) {
    return atan2(static_cast<double>(vectmp(a1, a2, b1, b2)),
                 static_cast<double>(scvmp(a1, a2, b1, b2)));
}

bool is_angle_in_pid4_0(const point a1, const point a2, const point b1, const point b2) {
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return vectmpv < 0 && -vectmpv < scvmp(a1, a2, b1, b2);
}

bool is_angle_in_0_pid4(const point a1, const point a2, const point b1, const point b2) {
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return 0 < vectmpv && vectmpv < scvmp(a1, a2, b1, b2);
}

bool is_angle_le_pid4(const point a1, const point a2, const point b1, const point b2) {
    ll scvmpv = scvmp(a1, a2, b1, b2);
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return vectmpv <= 0 || 0 < vectmpv && vectmpv < scvmpv;
}

bool is_angle_in_npid4_pid4(const point a1, const point a2, const point b1, const point b2) {
    ll scvmpv = scvmp(a1, a2, b1, b2);
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return 0 <= scvmpv && scvmpv > abs(vectmpv);
}

bool is_angle_leq_npid4(const point a1, const point a2, const point b1, const point b2) {
    ll scvmpv = scvmp(a1, a2, b1, b2);
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return scvmpv <= 0 && vectmpv <= 0 || 0 < scvmpv && scvmpv <= -vectmpv;
}

bool is_angle_0(const point a1, const point a2, const point b1, const point b2) {
    return vectmp(a1, a2, b1, b2) == 0 && scvmp(a1, a2, b1, b2) > 0;
}

const double PI = acos(-1.0);
const double PId2 = asin(1.0);
const double PId4 = atan(1.0);

#define vs(v) "(" << v.X << "," << v.Y << ")"
#undef db
#define db(x) 0;
#undef db_
#define db_(x) 0;

void solver() {
    int n, m, sn;
    cin >> n >> m >> sn;
    --sn;
    vector <point> points(n);
    vector < pair < pair < ll, int >, point >> points_dist(n); // dist, number, x, y
    fori(i, n) {
        cin >> points[i].X;
        cin >> points[i].Y;
    }
    point s = points[sn];
    fori(i, n) {
        points_dist[i].X.X = dist(s, points[i]);
        points_dist[i].X.Y = i;
    }
    vector < vector < pair < double, int>>> out_edges(n);
    vector <vector<cleg>> legs(n); // angle, edges dist, v_number
    vect spntup = mp(s, mp(s.X, s.Y - 1));
    vect spointdown = mp(s, mp(s.X, s.Y + 1));
    fori(i, m) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (points_dist[v].X.X < points_dist[u].X.X) {
            swap(u, v); // must be dist(u, s) < dist(v, s)
        }
        if (u == sn) {
            legs[sn].emplace_back(angle(spntup.X, spntup.Y, points[v], points[u]), mp(dist(points[v], points[u]), v));
        } else {
            legs[u].emplace_back(angle(points[u], s, points[v], points[u]), mp(dist(points[v], points[u]), v));
        }
        out_edges[v].emplace_back(angle(points[v], points[u], points[v], s), u);
    }
    sort(rall(points_dist));
    map < pair < int, int >, pair < pair < ll, int >, pair < int, int>>> dp;

    fori(j, n) {
        int i = points_dist[j].X.Y;
        db("see on " << i + 1)
        point &u = points[i];
        if (sn == i || legs[i].empty()) { continue; }
        sort(all(legs[i]));
        queue <pair<ll, int>> befq, aftq;
        set <pair<ll, int>> befs, afts;
        stack <pair<ll, int>> aftbuf;

        // смотрю входящие ребра, чтобы +- для каждого ребра
        vector <edges_dp_v> good_edgs;
        fori(k, legs[i].size()) {
            db("try? " << k << "(" << legs[i][k].Y.Y + 1 << ") " << befq.size() << " " << aftq.size())
            int vn = legs[i][k].Y.Y;
            point v = points[vn];
            int vl = -1, vr = -1;
            fori(qi, legs[i].size()) {
                int qn = legs[i][qi].Y.Y;
                const point &q = points[qn];
                if (dist(u, q) > dist(u, v)) { continue; }
                if (is_angle_in_0_pid4(v, u, q, u)) {
                    vl = qn;
                } else if (is_angle_in_pid4_0(v, u, q, u)) {
                    vr = qn;
                }
            }
            if (vl == -1 || vr == -1) { continue; }
            db("ok... " << i + 1 << "<- " << vn + 1 << "," << vl + 1 << "," << vr + 1)

            ll dp_v = dist(u, v);
            if (dp.find(mp(vn, i)) != dp.end()) { dp_v += dp[mp(vn, i)].X.X; }
            good_edgs.emplace_back(mp(dp_v, vn), mp(vl, vr));
            db("+ " << i + 1 << " " << vn + 1 << " " << dp_v)
        }

        if (good_edgs.empty()) { continue; }
        if (out_edges[i].empty()) { continue; }
        sort(all(out_edges[i]));
        for (auto ppn : out_edges[i]) {
            point &p = points[ppn.Y];
            edges_dp_v cur_dp = {{0, -1},
                                         {0, 0}};
            for (auto ge : good_edgs) {
                if (!is_angle_in_npid4_pid4(u, p, points[ge.X.Y], u)) { continue; }
                if (!is_angle_in_npid4_pid4(u, s, points[ge.X.Y], u)) { continue; }
                if (ge.X.X > cur_dp.X.X) {
                    cur_dp = ge;
                }
            }
            dp[mp(i, ppn.Y)] = cur_dp;
        }
    }

    db("start")
    point &u = s;
    pair <pair<ll, int>, pair<int, int>> dp_v(mp(0LL, -1), mp(-1, -1));
    if (legs[sn].size() > 1) {// стартовая вершина
        sort(all(legs[sn]));

        fori(k, legs[sn].size()) {
            int vn = legs[sn][k].Y.Y;
            int vl = -1, vr = -1;
            db("k = " << k << "(S<-" << vn + 1 << ")")
            point v = points[vn];
            fori(qi, legs[sn].size()) {
                int qn = legs[sn][qi].Y.Y;
                const point &q = points[qn];
                if (dist(u, q) > dist(u, v)) { continue; }
                if (is_angle_in_0_pid4(v, s, q, s)) {
                    vl = qn;
                } else if (is_angle_in_pid4_0(v, s, q, s)) {
                    vr = qn;
                }
            }
            if (vl == -1 || vr == -1) { continue; }
            pair <pair<ll, int>, pair<int, int>> cur_dp_v;
            cur_dp_v.X.X = dist(v, s);
            if (dp.find(mp(vn, sn)) != dp.end()) { cur_dp_v.X.X += dp[mp(vn, sn)].X.X; }
            cur_dp_v.X.Y = vn;
            cur_dp_v.Y.X = vl;
            cur_dp_v.Y.Y = vr;
            if (cur_dp_v.X.X > dp_v.X.X) {
                dp_v = cur_dp_v;
            }
        }
    }

    auto cdp = dp_v;
    int nwp = sn;
    vector <tuple<int, int, int>> ans;
    while (nwp >= 0 && cdp.X.Y > -1) {
        ans.emplace_back(cdp.Y.X + 1, cdp.X.Y + 1, cdp.Y.Y + 1);
        int tt = nwp;
        nwp = cdp.X.Y;
        db(vs(mp(tt, nwp)))
        auto ff = mp(nwp, tt);
        if (dp.find(ff) == dp.end())
            break;
        cdp = dp[mp(nwp, tt)];
    }
    cout << ans.size() << " " << dp_v.X.X << "\n";
    for (auto pp : ans) {
        cout << get<0>(pp) << " " << get<1>(pp) << " " << get<2>(pp) << "\n";
    }
}

int main() {
    fastio;
//    if (solver() < 2) return 2;
    solver();
}
