#define _USE_MATH_DEFINES

#include<bits/stdc++.h>

typedef long long ll;
using namespace std;

ll mod = 998244353;
vector<pair<int, int>> a;
vector<vector<int>> e;
ll ans = 0;
vector<int> used;

int n, m, v;

double getAngle(pair<int, int> x, pair<int, int> y) {
    return acos(((ll) x.first * y.first + (ll) x.second * y.second)
                / sqrt((ll) x.first * x.first + (ll) x.second * x.second)
                / sqrt((ll) y.first * y.first + (ll) y.second * y.second));
}

pair<int, int> operator-(pair<int, int> a, pair<int, int> b) {
    return {a.first - b.first, a.second - b.second};
}

int vec(pair<int, int> a, pair<int, int> b) {
    ll v = (ll) a.first * b.second - (ll) a.second * b.first;
    return v == 0 ? v : abs(v) / (v);
}

ll dist(const pair<int, int> va, const pair<int, int> vb) {
    return ((ll) va.first - (ll) vb.first) * ((ll) va.first - (ll) vb.first) +
           ((ll) va.second - (ll) vb.second) * ((ll) va.second - (ll) vb.second);
}


double eps = 1e-9;
vector<int> path, pathAns, left_, leftAns, right_, rightAns;

void searchAns(ll h, int pred, int predpred) {
    if (ans < h) {
        pathAns = path;
        leftAns = left_;
        rightAns = right_;
    }
    ans = max(ans, h);

    for (int i = 0; i < n; i++) {
        if (used[i] || !e[pred][i]) {
            continue;
        }
        if (getAngle(a[i] - a[v], a[pred] - a[v]) > M_PI / 4 - eps) {
            continue;
        }
        for (int j = 0; j < n; j++) {
            if (used[j] || !e[pred][j] || i == j) {
                continue;
            }
            if (getAngle(a[i] - a[pred], a[j] - a[pred]) > M_PI / 4 - eps ||
                getAngle(a[i] - a[pred], a[j] - a[pred]) < eps) {
                continue;
            }

            for (int k = 0; k < n; k++) {
                if (used[k] || !e[pred][k] || i == k || j == k) {
                    continue;
                }
                if (getAngle(a[i] - a[pred], a[k] - a[pred]) > M_PI / 4 - eps ||
                    getAngle(a[i] - a[pred], a[k] - a[pred]) < eps) {
                    continue;
                }

                if (vec(a[i] - a[pred], a[j] - a[pred]) == vec(a[i] - a[pred], a[k] - a[pred])) {
                    continue;
                }
                if (dist(a[j], a[pred]) >= dist(a[i], a[pred]) ||
                    dist(a[k], a[pred]) >= dist(a[i], a[pred])) { continue; }
                if (predpred > -1 && getAngle(a[predpred] - a[pred], a[pred] - a[i]) > M_PI / 4 - eps) {
                    continue;
                }
                if (vec(a[i] - a[pred], a[j] - a[pred]) > 0) {
                    right_.push_back(j);
                    left_.push_back(k);
                } else {
                    right_.push_back(k);
                    left_.push_back(j);
                }
                used[i] = used[k] = used[j] = 1;
                path.push_back(i);
                searchAns(h + dist(a[i], a[pred]), i, pred);
                path.pop_back();
                left_.pop_back();
                right_.pop_back();
                used[i] = used[k] = used[j] = 0;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> v;
    v--;
    used.resize(n);
    a.resize(n);
    e.resize(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        e[x][y] = e[y][x] = 1;
    }
    used[v] = 1;
    path.push_back(v);
    pathAns.push_back(v);
    searchAns(0, v, -1);
    cout << leftAns.size() << " " << ans << "\n";
//    cout << pathAns[0] + 1 << '\n';
    for (int i = 0; i < leftAns.size(); i++) {
        cout << rightAns[i] + 1 << ' ' << pathAns[i + 1] + 1 << ' ' << leftAns[i] + 1 << '\n';
    }
    return 0;
}