using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const ll max_n = 1000000;
const ll max_a = 1000000000;

/*
 1 & ? & $n \le 3$ &
 2 & ? & $n \le 10$
 3 & ? & массив~--- это перестановка
 4 & ? & все числа в массиве различны и неотрицательны
 5 & ? & $\exists\ i\ |\ a_i = 0$
 6 & ? & каждое число в массиве встречается дважды
7 & ? & нет дополнительных ограничений
 */

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    inf.readEoln();
    if (validator.group() == "1") {
        ensuref(n <= 3, "n > 3");
    }
    if (validator.group() == "2") {
        ensuref(n <= 10, "n > 10");
    }
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt(-max_a, max_a, "a");
        if (i != n - 1) {
            inf.readSpace();
        }
    }
    sort(a.begin(), a.end());
    if (validator.group() == "3") {
        for (int i = 1; i <= n; i++) {
            ensuref(a[i - 1] == i, "not permutation");
        }
    }
    if (validator.group() == "4") {
        ensuref(a[0] > 0, "not positive");
        for (int i = 1; i < n; i++) {
            ensuref(a[i] > 0 && a[i - 1] < a[i], "not distinct or positive");
        }
    }
    if (validator.group() == "5") {
        ensuref(binary_search(a.begin(), a.end(), 0), "hasn't zero");
    }
    if (validator.group() == "6") {
        ensuref(n % 2 == 0, "odd");
        for (int i = 0; i < n; i += 2) {
            ensuref(a[i] == a[i + 1] && (i == n - 2 || a[i] != a[i + 2]), "not twice all number");
        }
    }
    inf.readEoln();
    inf.readEof();

    return 0;
}
