#!/usr/bin/env bash
#   *** validation ***
scripts/run-validator-tests.sh
scripts/run-checker-tests.sh

#    *** tests ***
mkdir -p tests
echo "Generating test #1"
scripts/gen-input-via-stdout.sh "wine files/gRnd.exe -n 6 -sq 2 -mq 2 -cq 2 -ma 10" "tests/01" 1
echo "Generating test #2"
scripts/gen-input-via-stdout.sh "wine files/gRnd.exe -n 5 -sq 2 -mq 2 -cq 2 -ma 8" "tests/02" 2
echo "Generating test #3"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 3 -sq 948 -cq 621 -mq 3431 -ws 2 -wc -1 -wm 10" "tests/03" 3
echo "Generating test #4"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 1 -sq 3049 -cq 1040 -mq 911 -ws -1 -wc 5 -wm -7" "tests/04" 4
echo "Generating test #5"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 1 -sq 4459 -cq 440 -mq 101 -ws -5 -wc 0 -wm 10" "tests/05" 5
echo "Generating test #6"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 1 -sq 1855 -cq 2441 -mq 704 -ws -3 -wc -8 -wm -8" "tests/06" 6
echo "Generating test #7"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 1031 -cq 2608 -mq 1361 -ws 10 -wc -8 -wm -10" "tests/07" 7
echo "Generating test #8"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 1326 -cq 2624 -mq 1050 -ws 7 -wc 5 -wm -10" "tests/08" 8
echo "Generating test #9"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 1753 -cq 195 -mq 3052 -ws 6 -wc -10 -wm -3" "tests/09" 9
echo "Generating test #10"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 1349 -cq 165 -mq 3486 -ws -4 -wc 5 -wm 7" "tests/10" 10
echo "Generating test #11"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 2433 -cq 834 -mq 1733 -ws 8 -wc -9 -wm 3" "tests/11" 11
echo "Generating test #12"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 535 -cq 420 -mq 4045 -ws -10 -wc 3 -wm -10" "tests/12" 12
echo "Generating test #13"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 101 -cq 4780 -mq 119 -ws 9 -wc -2 -wm 1" "tests/13" 13
echo "Generating test #14"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 1017 -cq 943 -mq 3040 -ws 4 -wc -6 -wm -8" "tests/14" 14
echo "Generating test #15"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 5000 -sq 1440 -cq 1620 -mq 1940 -ws 1 -wc 10 -wm -8" "tests/15" 15
echo "Generating test #16"
scripts/gen-input-via-stdout.sh "wine files/gRnd.exe -n 3 -sq 9 -cq 8 -mq 4 -ma 60 4b300c3f5a4c957d3b95ca7806a7ad22" "tests/16" 16
echo "Generating test #17"
scripts/gen-input-via-stdout.sh "wine files/gRnd.exe -n 22 -sq 907 -cq 776 -mq 705 -ma 625134737 99334bf346c2e93e8316b93df44a60c4" "tests/17" 17
echo "Generating test #18"
scripts/gen-input-via-stdout.sh "wine files/gRnd.exe -n 82 -sq 835 -cq 653 -mq 102 -ma 893357430 217235400cd0743d788ab3361f7baea7" "tests/18" 18
echo "Generating test #19"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 77249 -cq 58948 -mq 63803 -ws 2 -wc -1 -wm 10" "tests/19" 19
echo "Generating test #20"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws -8 -wc -10 -wm 11 19ed613f8f04738946167fae4208a90f" "tests/20" 20
echo "Generating test #21"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws 8 -wc -8 -wm 18 9daa19e85693029ff8b919eaccb885bc" "tests/21" 21
echo "Generating test #22"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws 20 -wc -10 -wm 15 1098657be831b4ecba8145141dbf3b1b" "tests/22" 22
echo "Generating test #23"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws -9 -wc -9 -wm 18 9c42312504b9586325b85c814fb36b27" "tests/23" 23
echo "Generating test #24"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 52719 -cq 68708 -mq 78573 -ws -10 -wc -8 -wm 3" "tests/24" 24
echo "Generating test #25"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws -5 -wc -7 -wm 17 0b64d454075789cde64c6b7f07bc41a9" "tests/25" 25
echo "Generating test #26"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws 9 -wc -2 -wm 8 949bb061ea1eadafe64c05f78d63b341" "tests/26" 26
echo "Generating test #27"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws 20 -wc -8 -wm 20 ca34e7caab23a83a47994fb9973cbac9" "tests/27" 27
echo "Generating test #28"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 66666 -cq 66666 -mq 66666 -ws 2 -wc -3 -wm 18 6d574de26115d5559fdf612ccc87a363" "tests/28" 28
echo "Generating test #29"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 145171 -cq 17199 -mq 37630 -ws 9 -wc 2 -wm -10" "tests/29" 29
echo "Generating test #30"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 72959 -cq 105023 -mq 22018 -ws -2 -wc -1 -wm 9" "tests/30" 30
echo "Generating test #31"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 2 -sq 41885 -cq 147621 -mq 10494 -ws -10 -wc 3 -wm -10" "tests/31" 31
echo "Generating test #32"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 22652 -cq 164520 -mq 12828 -ws 10 -wc -8 -wm -5" "tests/32" 32
echo "Generating test #33"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 66666 -cq 66666 -mq 66666 -ws -1 -wc -7 -wm 6 a9077f9dd198b584cbe1b01477119913" "tests/33" 33
echo "Generating test #34"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 66666 -cq 66666 -mq 66666 -ws 16 -wc -4 -wm 15 e784cbe54bd367292c9d8b74a5c621c2" "tests/34" 34
echo "Generating test #35"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 66666 -cq 66666 -mq 66666 -ws 17 -wc -5 -wm 18 aeabd5e408769dcc3452eb12a90addb7" "tests/35" 35
echo "Generating test #36"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 66666 -cq 66666 -mq 66666 -ws 0 -wc -10 -wm 14 5f63874c2907289531ba4f86770706c4" "tests/36" 36
echo "Generating test #37"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 42375 -cq 137790 -mq 19835 -ws 4 -wc 7 -wm -8" "tests/37" 37
echo "Generating test #38"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 6578 -cq 63905 -mq 129517 -ws 9 -wc -1 -wm 7" "tests/38" 38
echo "Generating test #39"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 1 -sq 3275 -cq 135507 -mq 61218 -ws 6 -wc -6 -wm 7 -wz 4" "tests/39" 39
echo "Generating test #40"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 1 -sq 34022 -cq 101376 -mq 64602 -ws 5 -wc 2 -wm -2 -wz -4" "tests/40" 40
echo "Generating test #41"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 1 -sq 4307 -cq 59937 -mq 135756 -ws 6 -wc 8 -wm -8 -wz 13" "tests/41" 41
echo "Generating test #42"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 1 -sq 129492 -cq 15858 -mq 54650 -ws -2 -wc -3 -wm -5 -wz 15" "tests/42" 42
echo "Generating test #43"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 1 -sq 40985 -cq 121141 -mq 37874 -ws -1 -wc 0 -wm 2 -wz 2" "tests/43" 43
echo "Generating test #44"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 5218 -cq 183096 -mq 11686 -ws 9 -wc -4 -wm 5" "tests/44" 44
echo "Generating test #45"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 20411 -cq 155558 -mq 24031 -ws -5 -wc 5 -wm 9" "tests/45" 45
echo "Generating test #46"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 89267 -cq 14706 -mq 96027 -ws 7 -wc 5 -wm 5" "tests/46" 46
echo "Generating test #47"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 80104 -cq 43831 -mq 76065 -ws 2 -wc 5 -wm -6" "tests/47" 47
echo "Generating test #48"
scripts/gen-input-via-stdout.sh "wine files/genG23.exe -n 200000 -g 3 -sq 169704 -cq 7470 -mq 22826 -ws -2 -wc 2 -wm 6" "tests/48" 48
echo "Generating test #49"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 0 -sq 171617 -cq 0 -mq 28383 -ws 1 -wc -2 -wm -5 -wz -4" "tests/49" 49
echo "Generating test #50"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 0 -sq 102256 -cq 0 -mq 97744 -ws -7 -wc 6 -wm 6 -wz 6" "tests/50" 50
echo "Generating test #51"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 158572 -cq 0 -mq 41428 -ws -4 -wc -7 -wm 7" "tests/51" 51
echo "Generating test #52"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 104313 -cq 0 -mq 95687 -ws -1 -wc 2 -wm -1" "tests/52" 52
echo "Generating test #53"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 125645 -cq 0 -mq 74355 -ws -8 -wc -8 -wm 9" "tests/53" 53
echo "Generating test #54"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 47860 -cq 0 -mq 152140 -ws -2 -wc -2 -wm -10" "tests/54" 54
echo "Generating test #55"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 190764 -cq 0 -mq 9236 -ws 6 -wc 3 -wm 4" "tests/55" 55
echo "Generating test #56"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 33065 -cq 0 -mq 166935 -ws -5 -wc -10 -wm 10" "tests/56" 56
echo "Generating test #57"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 103756 -cq 0 -mq 96244 -ws -8 -wc 5 -wm 0" "tests/57" 57
echo "Generating test #58"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 192538 -cq 0 -mq 7462 -ws 6 -wc -10 -wm -6" "tests/58" 58
echo "Generating test #59"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 11390 -cq 0 -mq 188610 -ws -7 -wc -7 -wm -6" "tests/59" 59
echo "Generating test #60"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 69022 -cq 0 -mq 130978 -ws 7 -wc 7 -wm 3" "tests/60" 60
echo "Generating test #61"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 188165 -cq 0 -mq 11835 -ws -10 -wc 1 -wm -9" "tests/61" 61
echo "Generating test #62"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 88909 -cq 0 -mq 111091 -ws -7 -wc -2 -wm 1" "tests/62" 62
echo "Generating test #63"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 0 -sq 100912 -cq 0 -mq 99088 -ws -5 -wc -2 -wm -4 -wz 15" "tests/63" 63
echo "Generating test #64"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 0 -sq 75937 -cq 0 -mq 124063 -ws 4 -wc -7 -wm 5 -wz 0" "tests/64" 64
echo "Generating test #65"
scripts/gen-input-via-stdout.sh "wine files/genManyZeroes.exe -p2 0 -sq 155851 -cq 0 -mq 44149 -ws -4 -wc 1 -wm -10 -wz 4" "tests/65" 65
echo "Generating test #66"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws -23 -wm -1 -wz -1" "tests/66" 66
echo "Generating test #67"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 7 -wm -6 -wz -1" "tests/67" 67
echo "Generating test #68"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 5 -wm 10 -wz -1" "tests/68" 68
echo "Generating test #69"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 19 -wm 27 -wz -1" "tests/69" 69
echo "Generating test #70"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 3 -wm -8 -wz -1" "tests/70" 70
echo "Generating test #71"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 22 -wm -7 -wz -1" "tests/71" 71
echo "Generating test #72"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 28 -wm -20 -wz -1" "tests/72" 72
echo "Generating test #73"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 4 -wm -29 -wz 3" "tests/73" 73
echo "Generating test #74"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 18 -wm -23 -wz 10" "tests/74" 74
echo "Generating test #75"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws 1 -wm 5 -wz 7" "tests/75" 75
echo "Generating test #76"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws -17 -wm 10 -wz -1" "tests/76" 76
echo "Generating test #77"
scripts/gen-input-via-stdout.sh "wine files/genPointSets.exe -n 200000 -q 200000 -ws -16 -wm -23 -wz -1" "tests/77" 77
echo "Generating test #78"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws 9 -wm -22 -wc 9 -mz 0" "tests/78" 78
echo "Generating test #79"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws 21 -wm -19 -wc 8 -mz 0" "tests/79" 79
echo "Generating test #80"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws 12 -wm 8 -wc 3 -mz 0" "tests/80" 80
echo "Generating test #81"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -1 -wm -6 -wc 1 -mz 1" "tests/81" 81
echo "Generating test #82"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -20 -wm 5 -wc 7 -mz 0" "tests/82" 82
echo "Generating test #83"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -13 -wm 4 -wc -18 -mz 1 6e60edba041ed342e11bbc08b4d6724e" "tests/83" 83
echo "Generating test #84"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -9 -wm 3 -wc -4 -mz 1 3f3e0b3c859d24e6072189a3cbe60ce7" "tests/84" 84
echo "Generating test #85"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -7 -wm 12 -wc -15 -mz 0 552b3221efca86f6cef882c0626562b2" "tests/85" 85
echo "Generating test #86"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -13 -wm 9 -wc 7 -mz 0" "tests/86" 86
echo "Generating test #87"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -3 -wm 4 -wc -6 -mz 1 5a5833496b002174c4944b4627a360fd" "tests/87" 87
echo "Generating test #88"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws 11 -wm 23 -wc 2 -mz 0" "tests/88" 88
echo "Generating test #89"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -30 -wm -7 -wc 7 -mz 1" "tests/89" 89
echo "Generating test #90"
scripts/gen-input-via-stdout.sh "wine files/genSmall.exe -n 200000 -q 200000 -ws -30 -wm 15 -wc 9 -mz 1" "tests/90" 90
echo "Generating test #91"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 500 -cq 500 -mq 9000 -ws 6 -wc 3 -wm 4" "tests/91" 91
echo "Generating test #92"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 1000 -cq 1000 -mq 7000 -ws -5 -wc -10 -wm 10" "tests/92" 92
echo "Generating test #93"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 50 -cq 50 -mq 7000 -ws 10 -wc -10 -wm 13" "tests/93" 93
echo "Generating test #94"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 50 -cq 50 -mq 7900 -ws 0 -wc -10 -wm 15" "tests/94" 94
echo "Generating test #95"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 50 -cq 50 -mq 7900 -ws 10 -wc -10 -wm 17" "tests/95" 95
echo "Generating test #96"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 5465 -mq 2678 -cq 1857 -ws -18 -wm -30 -wc 6" "tests/96" 96
echo "Generating test #97"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 3237 -mq 5149 -cq 1614 -ws -29 -wm -22 -wc 3" "tests/97" 97
echo "Generating test #98"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 600 -mq 5189 -cq 4211 -ws 9 -wm 20 -wc 8" "tests/98" 98
echo "Generating test #99"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 357 -mq 4493 -cq 5150 -ws 5 -wm 24 -wc 3" "tests/99" 99
echo "Generating test #100"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 1844 -mq 6265 -cq 1891 -ws 23 -wm 27 -wc 8" "tests/100" 100
echo "Generating test #101"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 5486 -mq 1506 -cq 3008 -ws -27 -wm -24 -wc 1" "tests/101" 101
echo "Generating test #102"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 4 -mq 9863 -cq 133 -ws -22 -wm -6 -wc 3" "tests/102" 102
echo "Generating test #103"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 1001 -mq 3436 -cq 5563 -ws 29 -wm 28 -wc 3" "tests/103" 103
echo "Generating test #104"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 2890 -mq 5735 -cq 1375 -ws 23 -wm -5 -wc 6" "tests/104" 104
echo "Generating test #105"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 100000 -sq 4534 -mq 4129 -cq 1337 -ws 6 -wm 18 -wc 10" "tests/105" 105
echo "Generating test #106"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws -21 -wm -8 -wc 1" "tests/106" 106
echo "Generating test #107"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws 2 -wm -26 -wc 10" "tests/107" 107
echo "Generating test #108"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws 10 -wc -551 -wm 4 e095518fb8babea8da22859f8449e733" "tests/108" 108
echo "Generating test #109"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws -1 -wm 20 -wc 0" "tests/109" 109
echo "Generating test #110"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws -3 -wc -731 -wm -8 995f2fdfbff0383f4ba6ef7a75e2064a" "tests/110" 110
echo "Generating test #111"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws -8 -wc -997 -wm -9 802c24449ea26a89710d52ad43cc72bc" "tests/111" 111
echo "Generating test #112"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws -9 -wc -905 -wm 8 79aa54a7abee9f8ebb4498d6c6a5caee" "tests/112" 112
echo "Generating test #113"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws 22 -wm 16 -wc 6" "tests/113" 113
echo "Generating test #114"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws 10 -wm -11 -wc 3" "tests/114" 114
echo "Generating test #115"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws -12 -wm 11 -wc 1" "tests/115" 115
echo "Generating test #116"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws -25 -wm 25 -wc 9" "tests/116" 116
echo "Generating test #117"
scripts/gen-input-via-stdout.sh "wine files/gen8.exe -n 200000 -ws 8 -wm 11 -wc 4" "tests/117" 117
echo "Generating test #118"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 119363 -cq 40141 -mq 40496 -ws 8 -wc -1 -wm 9" "tests/118" 118
echo "Generating test #119"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 54633 -cq 38035 -mq 107332 -ws -7 -wc -9 -wm -9" "tests/119" 119
echo "Generating test #120"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 18203 -cq 58793 -mq 123004 -ws -4 -wc -10 -wm -1" "tests/120" 120
echo "Generating test #121"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 99900 -cq 100 -mq 100000 -ws 5 -wc -639 -wm -5 ca4a86c17e6fc7922845608a45a201a9" "tests/121" 121
echo "Generating test #122"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 99900 -cq 100 -mq 100000 -ws -6 -wc -504 -wm -4 76c6219a46cdd4e894c5d935d28711ca" "tests/122" 122
echo "Generating test #123"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 99900 -cq 100 -mq 100000 -ws -7 -wc -796 -wm -6 122d363b65fe85a0995b4ef8b34ab7e5" "tests/123" 123
echo "Generating test #124"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 69371 -cq 120211 -mq 10418 -ws 5 -wc 3 -wm 0" "tests/124" 124
echo "Generating test #125"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 186665 -cq 6827 -mq 6508 -ws -10 -wc 6 -wm -9" "tests/125" 125
echo "Generating test #126"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 99900 -cq 100 -mq 100000 -ws -4 -wc 0 -wm -8 d4ba43d953a92608d73bcb62e1734baa" "tests/126" 126
echo "Generating test #127"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 99900 -cq 100 -mq 100000 -ws 0 -wc 9 -wm -1 84180ca3e2397091132cce1d048c4282" "tests/127" 127
echo "Generating test #128"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 99900 -cq 100 -mq 100000 -ws 9 -wc -5 -wm 3 65de98347c7147c89b6d6ed90ca5c1df" "tests/128" 128
echo "Generating test #129"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 99900 -cq 100 -mq 100000 -ws 0 -wc 4 -wm 8 61fcff44beeb8ddbd5a5bce54e7b3bee" "tests/129" 129
echo "Generating test #130"
scripts/gen-input-via-stdout.sh "wine files/genFull.exe -n 200000 -sq 174506 -cq 1692 -mq 23802 -ws -6 -wc -10 -wm 5" "tests/130" 130
echo ""
echo "Generating answer for test #1"
scripts/gen-answer.sh tests/01 tests/01.a "tests" "0"
echo ""
echo "Generating answer for test #2"
scripts/gen-answer.sh tests/02 tests/02.a "tests" "0"
echo ""
echo "Generating answer for test #3"
scripts/gen-answer.sh tests/03 tests/03.a "tests" "1"
echo ""
echo "Generating answer for test #4"
scripts/gen-answer.sh tests/04 tests/04.a "tests" "1"
echo ""
echo "Generating answer for test #5"
scripts/gen-answer.sh tests/05 tests/05.a "tests" "1"
echo ""
echo "Generating answer for test #6"
scripts/gen-answer.sh tests/06 tests/06.a "tests" "1"
echo ""
echo "Generating answer for test #7"
scripts/gen-answer.sh tests/07 tests/07.a "tests" "1"
echo ""
echo "Generating answer for test #8"
scripts/gen-answer.sh tests/08 tests/08.a "tests" "1"
echo ""
echo "Generating answer for test #9"
scripts/gen-answer.sh tests/09 tests/09.a "tests" "1"
echo ""
echo "Generating answer for test #10"
scripts/gen-answer.sh tests/10 tests/10.a "tests" "1"
echo ""
echo "Generating answer for test #11"
scripts/gen-answer.sh tests/11 tests/11.a "tests" "1"
echo ""
echo "Generating answer for test #12"
scripts/gen-answer.sh tests/12 tests/12.a "tests" "1"
echo ""
echo "Generating answer for test #13"
scripts/gen-answer.sh tests/13 tests/13.a "tests" "1"
echo ""
echo "Generating answer for test #14"
scripts/gen-answer.sh tests/14 tests/14.a "tests" "1"
echo ""
echo "Generating answer for test #15"
scripts/gen-answer.sh tests/15 tests/15.a "tests" "1"
echo ""
echo "Generating answer for test #16"
scripts/gen-answer.sh tests/16 tests/16.a "tests" "1"
echo ""
echo "Generating answer for test #17"
scripts/gen-answer.sh tests/17 tests/17.a "tests" "1"
echo ""
echo "Generating answer for test #18"
scripts/gen-answer.sh tests/18 tests/18.a "tests" "1"
echo ""
echo "Generating answer for test #19"
scripts/gen-answer.sh tests/19 tests/19.a "tests" "2"
echo ""
echo "Generating answer for test #20"
scripts/gen-answer.sh tests/20 tests/20.a "tests" "2"
echo ""
echo "Generating answer for test #21"
scripts/gen-answer.sh tests/21 tests/21.a "tests" "2"
echo ""
echo "Generating answer for test #22"
scripts/gen-answer.sh tests/22 tests/22.a "tests" "2"
echo ""
echo "Generating answer for test #23"
scripts/gen-answer.sh tests/23 tests/23.a "tests" "2"
echo ""
echo "Generating answer for test #24"
scripts/gen-answer.sh tests/24 tests/24.a "tests" "2"
echo ""
echo "Generating answer for test #25"
scripts/gen-answer.sh tests/25 tests/25.a "tests" "2"
echo ""
echo "Generating answer for test #26"
scripts/gen-answer.sh tests/26 tests/26.a "tests" "2"
echo ""
echo "Generating answer for test #27"
scripts/gen-answer.sh tests/27 tests/27.a "tests" "2"
echo ""
echo "Generating answer for test #28"
scripts/gen-answer.sh tests/28 tests/28.a "tests" "2"
echo ""
echo "Generating answer for test #29"
scripts/gen-answer.sh tests/29 tests/29.a "tests" "2"
echo ""
echo "Generating answer for test #30"
scripts/gen-answer.sh tests/30 tests/30.a "tests" "2"
echo ""
echo "Generating answer for test #31"
scripts/gen-answer.sh tests/31 tests/31.a "tests" "2"
echo ""
echo "Generating answer for test #32"
scripts/gen-answer.sh tests/32 tests/32.a "tests" "3"
echo ""
echo "Generating answer for test #33"
scripts/gen-answer.sh tests/33 tests/33.a "tests" "3"
echo ""
echo "Generating answer for test #34"
scripts/gen-answer.sh tests/34 tests/34.a "tests" "3"
echo ""
echo "Generating answer for test #35"
scripts/gen-answer.sh tests/35 tests/35.a "tests" "3"
echo ""
echo "Generating answer for test #36"
scripts/gen-answer.sh tests/36 tests/36.a "tests" "3"
echo ""
echo "Generating answer for test #37"
scripts/gen-answer.sh tests/37 tests/37.a "tests" "3"
echo ""
echo "Generating answer for test #38"
scripts/gen-answer.sh tests/38 tests/38.a "tests" "3"
echo ""
echo "Generating answer for test #39"
scripts/gen-answer.sh tests/39 tests/39.a "tests" "3"
echo ""
echo "Generating answer for test #40"
scripts/gen-answer.sh tests/40 tests/40.a "tests" "3"
echo ""
echo "Generating answer for test #41"
scripts/gen-answer.sh tests/41 tests/41.a "tests" "3"
echo ""
echo "Generating answer for test #42"
scripts/gen-answer.sh tests/42 tests/42.a "tests" "3"
echo ""
echo "Generating answer for test #43"
scripts/gen-answer.sh tests/43 tests/43.a "tests" "3"
echo ""
echo "Generating answer for test #44"
scripts/gen-answer.sh tests/44 tests/44.a "tests" "3"
echo ""
echo "Generating answer for test #45"
scripts/gen-answer.sh tests/45 tests/45.a "tests" "3"
echo ""
echo "Generating answer for test #46"
scripts/gen-answer.sh tests/46 tests/46.a "tests" "3"
echo ""
echo "Generating answer for test #47"
scripts/gen-answer.sh tests/47 tests/47.a "tests" "3"
echo ""
echo "Generating answer for test #48"
scripts/gen-answer.sh tests/48 tests/48.a "tests" "3"
echo ""
echo "Generating answer for test #49"
scripts/gen-answer.sh tests/49 tests/49.a "tests" "4"
echo ""
echo "Generating answer for test #50"
scripts/gen-answer.sh tests/50 tests/50.a "tests" "4"
echo ""
echo "Generating answer for test #51"
scripts/gen-answer.sh tests/51 tests/51.a "tests" "4"
echo ""
echo "Generating answer for test #52"
scripts/gen-answer.sh tests/52 tests/52.a "tests" "4"
echo ""
echo "Generating answer for test #53"
scripts/gen-answer.sh tests/53 tests/53.a "tests" "4"
echo ""
echo "Generating answer for test #54"
scripts/gen-answer.sh tests/54 tests/54.a "tests" "4"
echo ""
echo "Generating answer for test #55"
scripts/gen-answer.sh tests/55 tests/55.a "tests" "4"
echo ""
echo "Generating answer for test #56"
scripts/gen-answer.sh tests/56 tests/56.a "tests" "4"
echo ""
echo "Generating answer for test #57"
scripts/gen-answer.sh tests/57 tests/57.a "tests" "4"
echo ""
echo "Generating answer for test #58"
scripts/gen-answer.sh tests/58 tests/58.a "tests" "4"
echo ""
echo "Generating answer for test #59"
scripts/gen-answer.sh tests/59 tests/59.a "tests" "4"
echo ""
echo "Generating answer for test #60"
scripts/gen-answer.sh tests/60 tests/60.a "tests" "4"
echo ""
echo "Generating answer for test #61"
scripts/gen-answer.sh tests/61 tests/61.a "tests" "4"
echo ""
echo "Generating answer for test #62"
scripts/gen-answer.sh tests/62 tests/62.a "tests" "4"
echo ""
echo "Generating answer for test #63"
scripts/gen-answer.sh tests/63 tests/63.a "tests" "4"
echo ""
echo "Generating answer for test #64"
scripts/gen-answer.sh tests/64 tests/64.a "tests" "4"
echo ""
echo "Generating answer for test #65"
scripts/gen-answer.sh tests/65 tests/65.a "tests" "4"
echo ""
echo "Generating answer for test #66"
scripts/gen-answer.sh tests/66 tests/66.a "tests" "5"
echo ""
echo "Generating answer for test #67"
scripts/gen-answer.sh tests/67 tests/67.a "tests" "5"
echo ""
echo "Generating answer for test #68"
scripts/gen-answer.sh tests/68 tests/68.a "tests" "5"
echo ""
echo "Generating answer for test #69"
scripts/gen-answer.sh tests/69 tests/69.a "tests" "5"
echo ""
echo "Generating answer for test #70"
scripts/gen-answer.sh tests/70 tests/70.a "tests" "5"
echo ""
echo "Generating answer for test #71"
scripts/gen-answer.sh tests/71 tests/71.a "tests" "5"
echo ""
echo "Generating answer for test #72"
scripts/gen-answer.sh tests/72 tests/72.a "tests" "5"
echo ""
echo "Generating answer for test #73"
scripts/gen-answer.sh tests/73 tests/73.a "tests" "5"
echo ""
echo "Generating answer for test #74"
scripts/gen-answer.sh tests/74 tests/74.a "tests" "5"
echo ""
echo "Generating answer for test #75"
scripts/gen-answer.sh tests/75 tests/75.a "tests" "5"
echo ""
echo "Generating answer for test #76"
scripts/gen-answer.sh tests/76 tests/76.a "tests" "5"
echo ""
echo "Generating answer for test #77"
scripts/gen-answer.sh tests/77 tests/77.a "tests" "5"
echo ""
echo "Generating answer for test #78"
scripts/gen-answer.sh tests/78 tests/78.a "tests" "6"
echo ""
echo "Generating answer for test #79"
scripts/gen-answer.sh tests/79 tests/79.a "tests" "6"
echo ""
echo "Generating answer for test #80"
scripts/gen-answer.sh tests/80 tests/80.a "tests" "6"
echo ""
echo "Generating answer for test #81"
scripts/gen-answer.sh tests/81 tests/81.a "tests" "6"
echo ""
echo "Generating answer for test #82"
scripts/gen-answer.sh tests/82 tests/82.a "tests" "6"
echo ""
echo "Generating answer for test #83"
scripts/gen-answer.sh tests/83 tests/83.a "tests" "6"
echo ""
echo "Generating answer for test #84"
scripts/gen-answer.sh tests/84 tests/84.a "tests" "6"
echo ""
echo "Generating answer for test #85"
scripts/gen-answer.sh tests/85 tests/85.a "tests" "6"
echo ""
echo "Generating answer for test #86"
scripts/gen-answer.sh tests/86 tests/86.a "tests" "6"
echo ""
echo "Generating answer for test #87"
scripts/gen-answer.sh tests/87 tests/87.a "tests" "6"
echo ""
echo "Generating answer for test #88"
scripts/gen-answer.sh tests/88 tests/88.a "tests" "6"
echo ""
echo "Generating answer for test #89"
scripts/gen-answer.sh tests/89 tests/89.a "tests" "6"
echo ""
echo "Generating answer for test #90"
scripts/gen-answer.sh tests/90 tests/90.a "tests" "6"
echo ""
echo "Generating answer for test #91"
scripts/gen-answer.sh tests/91 tests/91.a "tests" "7"
echo ""
echo "Generating answer for test #92"
scripts/gen-answer.sh tests/92 tests/92.a "tests" "7"
echo ""
echo "Generating answer for test #93"
scripts/gen-answer.sh tests/93 tests/93.a "tests" "7"
echo ""
echo "Generating answer for test #94"
scripts/gen-answer.sh tests/94 tests/94.a "tests" "7"
echo ""
echo "Generating answer for test #95"
scripts/gen-answer.sh tests/95 tests/95.a "tests" "7"
echo ""
echo "Generating answer for test #96"
scripts/gen-answer.sh tests/96 tests/96.a "tests" "7"
echo ""
echo "Generating answer for test #97"
scripts/gen-answer.sh tests/97 tests/97.a "tests" "7"
echo ""
echo "Generating answer for test #98"
scripts/gen-answer.sh tests/98 tests/98.a "tests" "7"
echo ""
echo "Generating answer for test #99"
scripts/gen-answer.sh tests/99 tests/99.a "tests" "7"
echo ""
echo "Generating answer for test #100"
scripts/gen-answer.sh tests/100 tests/100.a "tests" "7"
echo ""
echo "Generating answer for test #101"
scripts/gen-answer.sh tests/101 tests/101.a "tests" "7"
echo ""
echo "Generating answer for test #102"
scripts/gen-answer.sh tests/102 tests/102.a "tests" "7"
echo ""
echo "Generating answer for test #103"
scripts/gen-answer.sh tests/103 tests/103.a "tests" "7"
echo ""
echo "Generating answer for test #104"
scripts/gen-answer.sh tests/104 tests/104.a "tests" "7"
echo ""
echo "Generating answer for test #105"
scripts/gen-answer.sh tests/105 tests/105.a "tests" "7"
echo ""
echo "Generating answer for test #106"
scripts/gen-answer.sh tests/106 tests/106.a "tests" "8"
echo ""
echo "Generating answer for test #107"
scripts/gen-answer.sh tests/107 tests/107.a "tests" "8"
echo ""
echo "Generating answer for test #108"
scripts/gen-answer.sh tests/108 tests/108.a "tests" "8"
echo ""
echo "Generating answer for test #109"
scripts/gen-answer.sh tests/109 tests/109.a "tests" "8"
echo ""
echo "Generating answer for test #110"
scripts/gen-answer.sh tests/110 tests/110.a "tests" "8"
echo ""
echo "Generating answer for test #111"
scripts/gen-answer.sh tests/111 tests/111.a "tests" "8"
echo ""
echo "Generating answer for test #112"
scripts/gen-answer.sh tests/112 tests/112.a "tests" "8"
echo ""
echo "Generating answer for test #113"
scripts/gen-answer.sh tests/113 tests/113.a "tests" "8"
echo ""
echo "Generating answer for test #114"
scripts/gen-answer.sh tests/114 tests/114.a "tests" "8"
echo ""
echo "Generating answer for test #115"
scripts/gen-answer.sh tests/115 tests/115.a "tests" "8"
echo ""
echo "Generating answer for test #116"
scripts/gen-answer.sh tests/116 tests/116.a "tests" "8"
echo ""
echo "Generating answer for test #117"
scripts/gen-answer.sh tests/117 tests/117.a "tests" "8"
echo ""
echo "Generating answer for test #118"
scripts/gen-answer.sh tests/118 tests/118.a "tests" "9"
echo ""
echo "Generating answer for test #119"
scripts/gen-answer.sh tests/119 tests/119.a "tests" "9"
echo ""
echo "Generating answer for test #120"
scripts/gen-answer.sh tests/120 tests/120.a "tests" "9"
echo ""
echo "Generating answer for test #121"
scripts/gen-answer.sh tests/121 tests/121.a "tests" "9"
echo ""
echo "Generating answer for test #122"
scripts/gen-answer.sh tests/122 tests/122.a "tests" "9"
echo ""
echo "Generating answer for test #123"
scripts/gen-answer.sh tests/123 tests/123.a "tests" "9"
echo ""
echo "Generating answer for test #124"
scripts/gen-answer.sh tests/124 tests/124.a "tests" "9"
echo ""
echo "Generating answer for test #125"
scripts/gen-answer.sh tests/125 tests/125.a "tests" "9"
echo ""
echo "Generating answer for test #126"
scripts/gen-answer.sh tests/126 tests/126.a "tests" "9"
echo ""
echo "Generating answer for test #127"
scripts/gen-answer.sh tests/127 tests/127.a "tests" "9"
echo ""
echo "Generating answer for test #128"
scripts/gen-answer.sh tests/128 tests/128.a "tests" "9"
echo ""
echo "Generating answer for test #129"
scripts/gen-answer.sh tests/129 tests/129.a "tests" "9"
echo ""
echo "Generating answer for test #130"
scripts/gen-answer.sh tests/130 tests/130.a "tests" "9"
echo ""

