#include "testlib.h"

using namespace std;


const int shift = 29;


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    auto n = opt<int>("n"), sumQ = opt<int>("sq"),
            changeQ = opt<int>("cq"), modifyQ = opt<int>("mq");
    auto wS = opt<int>("ws"), wM = opt<int>("wm"), wC = opt<int>("wc");
    auto group = opt<int8_t>("g");
    int powBound = (group == 2 ? 0 : -1);
    cout << n << " " << sumQ + changeQ + modifyQ << "\n";
    for (int i = 0; i < n; i++) {
        int pw = rnd.next(powBound, shift);
        int res = 0;
        if (pw >= 0) {
            res = (1 << pw);
        }
        cout << res;
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    vector<vector<int>> queries;
    for (int i = 0; i < sumQ; i++) {
        int len = rnd.wnext(n, wS);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({1, l, r});
    }
    for (int i = 0; i < changeQ; i++) {
        int pw = rnd.next(powBound, shift);
        int res = 0;
        if (pw >= 0) {
            res = (1 << pw);
        }
        int len = rnd.wnext(n, wC);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({2, l, r, res});
    }
    for (int i = 0; i < modifyQ; i++) {
        int len = rnd.wnext(n, wM);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({3, l, r});
    }
    shuffle(queries.begin(), queries.end());
    for (auto &q : queries) {
        for (size_t i = 0; i < q.size(); i++) {
            cout << q[i];
            if (i + 1 == q.size()) {
                cout << "\n";
            } else {
                cout << " ";
            }
        }
    }
}
