#include "testlib.h"

using namespace std;


const int shift = 29;
const int n = 200'000;


int getEl(bool isP2, int prob0) {
    if (rnd.wnext(2, prob0)) {
        return 0;
    }
    if (isP2) {
        return (1 << rnd.next(0, shift));
    } else {
        return rnd.next(1, 1'000'000'000);
    }
}


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    auto sumQ = opt<int>("sq"),
            changeQ = opt<int>("cq"), modifyQ = opt<int>("mq");
    auto wS = opt<int>("ws"), wM = opt<int>("wm"), wC = opt<int>("wc");
    auto wZ = opt<int>("wz");
    auto powersOfTwo = opt<int8_t>("p2");
    cout << n << " " << sumQ + changeQ + modifyQ << "\n";
    for (int i = 0; i < n; i++) {
        cout << getEl(powersOfTwo, wZ);
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    vector<vector<int>> queries;
    for (int i = 0; i < sumQ; i++) {
        int len = rnd.wnext(n, wS);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({1, l, r});
    }
    for (int i = 0; i < changeQ; i++) {
        int len = rnd.wnext(n, wC);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({2, l, r, getEl(powersOfTwo, wZ)});
    }
    for (int i = 0; i < modifyQ; i++) {
        int len = rnd.wnext(n, wM);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({3, l, r});
    }
    shuffle(queries.begin(), queries.end());
    for (auto &q : queries) {
        for (size_t i = 0; i < q.size(); i++) {
            cout << q[i];
            if (i + 1 == q.size()) {
                cout << "\n";
            } else {
                cout << " ";
            }
        }
    }
}
