#include "testlib.h"

using namespace std;

int maxA = 1'000'000'000;
int maxN = 200'000, maxM = 200'000;

void g1(int maxN, int maxQ) {
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, maxQ, "m");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        inf.readInt(0, maxA, "a");
        if (i + 1 == n) {
            inf.readEoln();
        } else {
            inf.readSpace();
        }
    }
    while (m--) {
        int type = inf.readInt(1, 3, "type");
        inf.readSpace();
        int l = inf.readInt(1, n, "l");
        inf.readSpace();
        inf.readInt(l, n, "r");
        if (type == 1 or type == 3) {
            inf.readEoln();
        } else {
            inf.readSpace();
            inf.readInt(0, maxA, "x");
            inf.readEoln();
        }
    }
}


void g23(int group) {
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, maxM, "m");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        int x = inf.readInt(0, maxA, "a");
        if (group == 2) {
            ensuref(__builtin_popcount(x) == 1, "Expected power of 2, but got %d", x);
        } else {
            ensuref(__builtin_popcount(x) <= 1, "Expected power of 2 or 0, but got %d", x);
        }
        if (i + 1 == n) {
            inf.readEoln();
        } else {
            inf.readSpace();
        }
    }
    while (m--) {
        int type = inf.readInt(1, 3, "type");
        inf.readSpace();
        int l = inf.readInt(1, n, "l");
        inf.readSpace();
        inf.readInt(l, n, "r");

        if (type == 1 or type == 3) {
            inf.readEoln();
        } else {
            inf.readSpace();
            int x = inf.readInt(0, maxA, "x");
            if (group == 2) {
                ensuref(__builtin_popcount(x) == 1, "Expected power of 2, but got %d", x);
            } else {
                ensuref(__builtin_popcount(x) <= 1, "Expected power of 2 or 0, but got %d", x);
            }
            inf.readEoln();
        }
    }
}


void g4() {
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, maxM, "m");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        inf.readInt(0, maxA, "a");
        if (i + 1 == n) {
            inf.readEoln();
        } else {
            inf.readSpace();
        }
    }
    while (m--) {
        int type = inf.readInt(1, 3, "type");
        ensuref(type != 2, "Forbidden query for group 4");
        inf.readSpace();
        int l = inf.readInt(1, n, "l");
        inf.readSpace();
        inf.readInt(l, n, "r");
        inf.readEoln();
    }
}


void g5() {
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, maxM, "m");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        inf.readInt(0, maxA, "a");
        if (i + 1 == n) {
            inf.readEoln();
        } else {
            inf.readSpace();
        }
    }
    while (m--) {
        int type = inf.readInt(1, 3, "type");
        inf.readSpace();
        int l = inf.readInt(1, n, "l");
        inf.readSpace();
        int r = inf.readInt(l, n, "r");
        if (type == 2) {
            inf.readSpace();
            ensuref(l == r, "Query must be a point");
            inf.readInt(0, maxA, "x");
        }
        inf.readEoln();
    }
}


void g9(int mv) {
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, maxM, "m");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        inf.readInt(0, mv, "a");
        if (i + 1 == n) {
            inf.readEoln();
        } else {
            inf.readSpace();
        }
    }
    while (m--) {
        int type = inf.readInt(1, 3, "type");
        inf.readSpace();
        int l = inf.readInt(1, n, "l");
        inf.readSpace();
        inf.readInt(l, n, "r");
        if (type == 1 or type == 3) {
            inf.readEoln();
        } else {
            inf.readSpace();
            inf.readInt(0, mv, "x");
            inf.readEoln();
        }
    }
}

void g8() {
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, maxM, "m");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        inf.readInt(0, maxA, "a");
        if (i + 1 == n) {
            inf.readEoln();
        } else {
            inf.readSpace();
        }
    }
    bool wasSum = false;
    while (m--) {
        int type = inf.readInt(1, 3, "type");
        wasSum |= (type == 1);
        ensuref(!(wasSum && type != 1), "Bad order");
        inf.readSpace();
        int l = inf.readInt(1, n, "l");
        inf.readSpace();
        inf.readInt(l, n, "r");
        if (type == 1 or type == 3) {
            inf.readEoln();
        } else {
            inf.readSpace();
            inf.readInt(0, maxA, "x");
            inf.readEoln();
        }
    }
}

int main(int argc, char** argv) {
    registerValidation(argc, argv);
    int g = atoi(validator.group().c_str());
    if (g == 1) {
        g1(5000, 5000);
    } else if (g == 2 or g == 3) {
        g23(g);
    } else if (g == 4) {
        g4();
    } else if (g == 5) {
        g5();
    } else if (g == 6) {
        g9(20);
    } else if (g == 8) {
        g8();
    } else if (g == 7) {
        g1(100000, 10000);
    } else {
        g9(maxA);
    }
    inf.readEof();
    return 0;
}